osl::rating::Feature Class Referenceabstract

`#include <feature.h>`

Inheritance diagram for osl::rating::Feature:

## Public Member Functions

| Feature (const std::string &name)
virtual | ~Feature ()
virtual bool | match (const NumEffectState &state, Move, const RatingEnv &) const =0
virtual bool | effectiveInCheck () const
const std::string & | name () const

## Private Attributes

std::string | my_name

## Detailed Description

Definition at line 14 of file rating/feature.h.

## Constructor & Destructor Documentation

## Feature()

osl::rating::Feature::Feature | ( | const std::string & | name | ) |

inline

Definition at line 18 of file rating/feature.h.

References my_name, and name().

Referenced by osl::rating::AttackKing8::AttackKing8(), osl::rating::BadLance::BadLance(), osl::rating::BigramAttack::BigramAttack(), osl::rating::Block::Block(), osl::rating::Capture::Capture(), osl::rating::Chase::Chase(), osl::rating::Check::Check(), osl::rating::CheckmateIfCapture::CheckmateIfCapture(), osl::rating::ContinueCapture::ContinueCapture(), osl::rating::DefenseKing8::DefenseKing8(), osl::rating::DropCaptured::DropCaptured(), osl::rating::EscapePin::EscapePin(), osl::rating::FromEffect::FromEffect(), osl::rating::ImmediateAddSupport::ImmediateAddSupport(), osl::rating::ImmediateEscape::ImmediateEscape(), osl::rating::Karanari::Karanari(), osl::rating::KingEscape::KingEscape(), osl::rating::Open::Open(), osl::rating::Pattern::Pattern(), osl::rating::Pattern::Pattern(), osl::rating::PatternBlock::PatternBlock(), osl::rating::PatternLong::PatternLong(), osl::rating::PatternLong2::PatternLong2(), osl::rating::PawnAttack::PawnAttack(), osl::rating::PinAttack::PinAttack(), osl::rating::PtypeAttacked::PtypeAttacked(), osl::rating::RelativeKingX::RelativeKingX(), osl::rating::RelativeKingY::RelativeKingY(), osl::rating::RookDefense::RookDefense(), osl::rating::SendOff::SendOff(), osl::rating::ShadowEffect1::ShadowEffect1(), osl::rating::ShadowEffect2::ShadowEffect2(), osl::rating::SquareX::SquareX(), osl::rating::SquareY::SquareY(), osl::rating::TakeBack::TakeBack(), osl::rating::TakeBack2::TakeBack2(), osl::rating::Threatmate::Threatmate(), and osl::rating::ToSupported::ToSupported().

## ~Feature()

osl::rating::Feature::~Feature | ( |  | ) |

virtual

Definition at line 7 of file feature.cc.

## Member Function Documentation

## effectiveInCheck()

virtual bool osl::rating::Feature::effectiveInCheck | ( |  | ) | const

inline virtual

Reimplemented in osl::rating::Block, osl::rating::Check, osl::rating::ImmediateAddSupport, osl::rating::KingEscape, osl::rating::Open, osl::rating::TakeBack2, and osl::rating::TakeBack.

Definition at line 23 of file rating/feature.h.

## match()

virtual bool osl::rating::Feature::match | ( | const NumEffectState & | state,
|  | Move | ,
|  | const RatingEnv & | ) const

pure virtual

Implemented in osl::rating::AttackKing8, osl::rating::BadLance, osl::rating::BigramAttack, osl::rating::Block, osl::rating::Capture, osl::rating::Chase, osl::rating::Check, osl::rating::CheckmateIfCapture, osl::rating::ContinueCapture, osl::rating::DefenseKing8, osl::rating::DropCaptured, osl::rating::EscapePin, osl::rating::FromEffect, osl::rating::ImmediateAddSupport, osl::rating::ImmediateEscape, osl::rating::Karanari, osl::rating::KingEscape, osl::rating::Open, osl::rating::Pattern, osl::rating::PatternBlock, osl::rating::PatternLong2, osl::rating::PatternLong, osl::rating::PawnAttack, osl::rating::PinAttack, osl::rating::PtypeAttacked, osl::rating::RelativeKingX, osl::rating::RelativeKingY, osl::rating::RookDefense, osl::rating::SendOff, osl::rating::ShadowEffect1, osl::rating::ShadowEffect2, osl::rating::SquareX, osl::rating::SquareY, osl::rating::TakeBack2, osl::rating::TakeBack, osl::rating::Threatmate, and osl::rating::ToSupported.

## name()

const std::string & osl::rating::Feature::name | ( |  | ) | const

inline

Definition at line 24 of file rating/feature.h.

References my_name.

Referenced by Feature(), osl::rating::FromEffect::FromEffect(), and osl::rating::PatternBlock::PatternBlock().

## Member Data Documentation

## my_name

std::string osl::rating::Feature::my_name

private

Definition at line 16 of file rating/feature.h.

Referenced by Feature(), and name().

The documentation for this class was generated from the following files:

- rating/feature.h
- feature.cc